diff --git a/src/backend/storage/ipc/standby.c b/src/backend/storage/ipc/standby.c
index 3e25f80652..0ba0f6dd09 100644
--- a/src/backend/storage/ipc/standby.c
+++ b/src/backend/storage/ipc/standby.c
@@ -1042,16 +1042,16 @@ StandbyReleaseXidEntryLocks(RecoveryLockXidEntry *xidentry)
 		LOCKTAG		locktag;
 
 		elog(DEBUG4,
-			 "releasing recovery lock: xid %llu db %u rel %u",
-			 (unsigned long long) entry->key.xid, entry->key.dbOid,
+			 "releasing recovery lock: xid %" PRIu64 " db %u rel %u",
+			 entry->key.xid, entry->key.dbOid,
 			 entry->key.relOid);
 		/* Release the lock ... */
 		SET_LOCKTAG_RELATION(locktag, entry->key.dbOid, entry->key.relOid);
 		if (!LockRelease(&locktag, AccessExclusiveLock, true))
 		{
 			elog(LOG,
-				 "RecoveryLockHash contains entry for lock no longer recorded by lock manager: xid %llu database %u relation %u",
-				 (unsigned long long) entry->key.xid, entry->key.dbOid,
+				 "RecoveryLockHash contains entry for lock no longer recorded by lock manager: xid %" PRIu64 " database %u relation %u",
+				 entry->key.xid, entry->key.dbOid,
 				 entry->key.relOid);
 			Assert(false);
 		}
@@ -1378,20 +1378,20 @@ LogCurrentRunningXacts(RunningTransactions CurrRunningXacts)
 
 	if (xlrec.subxid_overflow)
 		elog(DEBUG2,
-			 "snapshot of %d running transactions overflowed (lsn %X/%X oldest xid %llu latest complete %llu next xid %llu)",
+			 "snapshot of %d running transactions overflowed (lsn %X/%X oldest xid %" PRIu64 " latest complete %" PRIu64 " next xid %" PRIu64 ")",
 			 CurrRunningXacts->xcnt,
 			 LSN_FORMAT_ARGS(recptr),
-			 (unsigned long long) CurrRunningXacts->oldestRunningXid,
-			 (unsigned long long) CurrRunningXacts->latestCompletedXid,
-			 (unsigned long long) CurrRunningXacts->nextXid);
+			 CurrRunningXacts->oldestRunningXid,
+			 CurrRunningXacts->latestCompletedXid,
+			 CurrRunningXacts->nextXid);
 	else
 		elog(DEBUG2,
-			 "snapshot of %d+%d running transaction ids (lsn %X/%X oldest xid %llu latest complete %llu next xid %llu)",
+			 "snapshot of %d+%d running transaction ids (lsn %X/%X oldest xid %" PRIu64 " latest complete %" PRIu64 " next xid %" PRIu64 ")",
 			 CurrRunningXacts->xcnt, CurrRunningXacts->subxcnt,
 			 LSN_FORMAT_ARGS(recptr),
-			 (unsigned long long) CurrRunningXacts->oldestRunningXid,
-			 (unsigned long long) CurrRunningXacts->latestCompletedXid,
-			 (unsigned long long) CurrRunningXacts->nextXid);
+			 CurrRunningXacts->oldestRunningXid,
+			 CurrRunningXacts->latestCompletedXid,
+			 CurrRunningXacts->nextXid);
 
 	/*
 	 * Ensure running_xacts information is synced to disk not too far in the
diff --git a/src/backend/storage/lmgr/lmgr.c b/src/backend/storage/lmgr/lmgr.c
index 670df77d78..f04e5f131b 100644
--- a/src/backend/storage/lmgr/lmgr.c
+++ b/src/backend/storage/lmgr/lmgr.c
@@ -1289,8 +1289,7 @@ DescribeLockTag(StringInfo buf, const LOCKTAG *tag)
 				xid = (TransactionId) tag->locktag_field2 << 32;
 				xid += tag->locktag_field1;
 
-				appendStringInfo(buf, _("transaction %llu"),
-								 (unsigned long long) xid);
+				appendStringInfo(buf, _("transaction %" PRIu64), xid);
 				break;
 			}
 		case LOCKTAG_VIRTUALTRANSACTION:
diff --git a/src/backend/storage/lmgr/predicate.c b/src/backend/storage/lmgr/predicate.c
index 30a13d6d0a..1e7c1ba41a 100644
--- a/src/backend/storage/lmgr/predicate.c
+++ b/src/backend/storage/lmgr/predicate.c
@@ -4042,8 +4042,8 @@ CheckForSerializableConflictOut(Relation relation, TransactionId xid, Snapshot s
 				ereport(ERROR,
 						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 						 errmsg("could not serialize access due to read/write dependencies among transactions"),
-						 errdetail_internal("Reason code: Canceled on conflict out to old pivot %llu.",
-											(unsigned long long) xid),
+						 errdetail_internal("Reason code: Canceled on conflict out to old pivot %" PRIu64 ".",
+											xid),
 						 errhint("The transaction might succeed if retried.")));
 
 			if (SxactHasSummaryConflictIn(MySerializableXact)
@@ -4051,8 +4051,8 @@ CheckForSerializableConflictOut(Relation relation, TransactionId xid, Snapshot s
 				ereport(ERROR,
 						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 						 errmsg("could not serialize access due to read/write dependencies among transactions"),
-						 errdetail_internal("Reason code: Canceled on identification as a pivot, with conflict out to old committed transaction %llu.",
-											(unsigned long long) xid),
+						 errdetail_internal("Reason code: Canceled on identification as a pivot, with conflict out to old committed transaction %" PRIu64 ".",
+											xid),
 						 errhint("The transaction might succeed if retried.")));
 
 			MySerializableXact->flags |= SXACT_FLAG_SUMMARY_CONFLICT_OUT;
@@ -4652,8 +4652,8 @@ OnConflict_CheckForSerializationFailure(const SERIALIZABLEXACT *reader,
 			ereport(ERROR,
 					(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 					 errmsg("could not serialize access due to read/write dependencies among transactions"),
-					 errdetail_internal("Reason code: Canceled on conflict out to pivot %llu, during read.",
-										(unsigned long long) writer->topXid),
+					 errdetail_internal("Reason code: Canceled on conflict out to pivot %" PRIu64 ", during read.",
+										writer->topXid),
 					 errhint("The transaction might succeed if retried.")));
 		}
 		writer->flags |= SXACT_FLAG_DOOMED;
diff --git a/src/backend/utils/adt/lockfuncs.c b/src/backend/utils/adt/lockfuncs.c
index 264d6162ef..4ada07487b 100644
--- a/src/backend/utils/adt/lockfuncs.c
+++ b/src/backend/utils/adt/lockfuncs.c
@@ -80,8 +80,7 @@ VXIDGetDatum(ProcNumber procNumber, LocalTransactionId lxid)
 	 */
 	char		vxidstr[64];
 
-	snprintf(vxidstr, sizeof(vxidstr), "%d/%llu", procNumber,
-			 (unsigned long long) lxid);
+	snprintf(vxidstr, sizeof(vxidstr), "%d/%" PRIu64, procNumber, lxid);
 
 	return CStringGetTextDatum(vxidstr);
 }
diff --git a/src/backend/utils/adt/xid.c b/src/backend/utils/adt/xid.c
index 72d6196f82..70bd76aac0 100644
--- a/src/backend/utils/adt/xid.c
+++ b/src/backend/utils/adt/xid.c
@@ -45,7 +45,7 @@ xidout(PG_FUNCTION_ARGS)
 	TransactionId transactionId = PG_GETARG_TRANSACTIONID(0);
 	char	   *result = (char *) palloc(32);
 
-	snprintf(result, 32, "%llu", (unsigned long long) transactionId);
+	snprintf(result, 32, "%" PRIu64, transactionId);
 	PG_RETURN_CSTRING(result);
 }
 
diff --git a/src/backend/utils/error/csvlog.c b/src/backend/utils/error/csvlog.c
index 4708d7b299..10197a9fec 100644
--- a/src/backend/utils/error/csvlog.c
+++ b/src/backend/utils/error/csvlog.c
@@ -151,12 +151,12 @@ write_csvlog(ErrorData *edata)
 	/* Virtual transaction id */
 	/* keep VXID format in sync with lockfuncs.c */
 	if (MyProc != NULL && MyProc->vxid.procNumber != INVALID_PROC_NUMBER)
-		appendStringInfo(&buf, "%d/%llu", MyProc->vxid.procNumber,
-						 (unsigned long long) MyProc->vxid.lxid);
+		appendStringInfo(&buf, "%d/%" PRIu64, MyProc->vxid.procNumber,
+						 MyProc->vxid.lxid);
 	appendStringInfoChar(&buf, ',');
 
 	/* Transaction id */
-	appendStringInfo(&buf, "%llu", (unsigned long long) GetTopTransactionIdIfAny());
+	appendStringInfo(&buf, "%" PRIu64, GetTopTransactionIdIfAny());
 	appendStringInfoChar(&buf, ',');
 
 	/* Error severity */
diff --git a/src/backend/utils/error/elog.c b/src/backend/utils/error/elog.c
index 076389e084..d4898a2ea3 100644
--- a/src/backend/utils/error/elog.c
+++ b/src/backend/utils/error/elog.c
@@ -3164,15 +3164,15 @@ log_status_format(StringInfo buf, const char *format, ErrorData *edata)
 					{
 						char		strfbuf[128];
 
-						snprintf(strfbuf, sizeof(strfbuf) - 1, "%d/%llu",
+						snprintf(strfbuf, sizeof(strfbuf) - 1, "%d/%" PRIu64,
 								 MyProc->vxid.procNumber,
-								 (unsigned long long) MyProc->vxid.lxid);
+								 MyProc->vxid.lxid);
 						appendStringInfo(buf, "%*s", padding, strfbuf);
 					}
 					else
-						appendStringInfo(buf, "%d/%llu",
+						appendStringInfo(buf, "%d/%" PRIu64,
 										 MyProc->vxid.procNumber,
-										 (unsigned long long) MyProc->vxid.lxid);
+										 MyProc->vxid.lxid);
 				}
 				else if (padding != 0)
 					appendStringInfoSpaces(buf,
@@ -3180,11 +3180,11 @@ log_status_format(StringInfo buf, const char *format, ErrorData *edata)
 				break;
 			case 'x':
 				if (padding != 0)
-					appendStringInfo(buf, "%*llu", padding,
-									 (unsigned long long) GetTopTransactionIdIfAny());
+					appendStringInfo(buf, "%*" PRIu64, padding,
+									 GetTopTransactionIdIfAny());
 				else
-					appendStringInfo(buf, "%llu",
-									 (unsigned long long) GetTopTransactionIdIfAny());
+					appendStringInfo(buf, "%" PRIu64,
+									 GetTopTransactionIdIfAny());
 				break;
 			case 'e':
 				if (padding != 0)
diff --git a/src/backend/utils/error/jsonlog.c b/src/backend/utils/error/jsonlog.c
index 41de753c23..9d58ef0541 100644
--- a/src/backend/utils/error/jsonlog.c
+++ b/src/backend/utils/error/jsonlog.c
@@ -196,13 +196,13 @@ write_jsonlog(ErrorData *edata)
 	/* Virtual transaction id */
 	/* keep VXID format in sync with lockfuncs.c */
 	if (MyProc != NULL && MyProc->vxid.procNumber != INVALID_PROC_NUMBER)
-		appendJSONKeyValueFmt(&buf, "vxid", true, "%d/%llu",
+		appendJSONKeyValueFmt(&buf, "vxid", true, "%d/%" PRIu64,
 							  MyProc->vxid.procNumber,
-							  (unsigned long long) MyProc->vxid.lxid);
+							  MyProc->vxid.lxid);
 
 	/* Transaction id */
-	appendJSONKeyValueFmt(&buf, "txid", false, "%llu",
-						  (unsigned long long) GetTopTransactionIdIfAny());
+	appendJSONKeyValueFmt(&buf, "txid", false, "%" PRIu64,
+						  GetTopTransactionIdIfAny());
 
 	/* Error severity */
 	if (edata->elevel)
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index f35e5d1f95..95d73ca23a 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -1500,10 +1500,8 @@ check_GUC_init(struct config_generic *gconf)
 
 				if (*conf->variable != 0 && *conf->variable != conf->boot_val)
 				{
-					elog(LOG, "GUC (PGC_INT64) %s, boot_val=%lld, C-var=%lld",
-						 conf->gen.name,
-						 (long long) conf->boot_val,
-						 (long long) *conf->variable);
+					elog(LOG, "GUC (PGC_INT64) %s, boot_val=%" PRId64 ", C-var=%" PRId64,
+						 conf->gen.name, conf->boot_val, *conf->variable);
 					return false;
 				}
 				break;
@@ -1748,8 +1746,8 @@ InitializeOneGUCOption(struct config_generic *gconf)
 				Assert(newval <= conf->max);
 				if (!call_int64_check_hook(conf, &newval, &extra,
 										   PGC_S_DEFAULT, LOG))
-					elog(FATAL, "failed to initialize %s to %lld",
-						 conf->gen.name, (long long) newval);
+					elog(FATAL, "failed to initialize %s to %" PRId64,
+						 conf->gen.name, newval);
 				if (conf->assign_hook)
 					(*conf->assign_hook) (newval, extra);
 				*conf->variable = conf->reset_val = newval;
@@ -3370,9 +3368,9 @@ parse_and_validate_value(struct config_generic *record,
 				{
 					ereport(elevel,
 							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("%lld is outside the valid range for parameter \"%s\" (%lld .. %lld)",
-									(long long) newval->int64val, conf->gen.name,
-									(long long) conf->min, (long long) conf->max)));
+							 errmsg("%" PRId64 " is outside the valid range for parameter \"%s\" (%" PRId64 " .. %" PRId64 ")",
+									newval->int64val, conf->gen.name, conf->min,
+									conf->max)));
 					return false;
 				}
 
@@ -4658,8 +4656,8 @@ GetConfigOption(const char *name, bool missing_ok, bool restrict_privileged)
 			return buffer;
 
 		case PGC_INT64:
-			snprintf(buffer, sizeof(buffer), "%lld",
-					 (long long) *((struct config_int64 *) record)->variable);
+			snprintf(buffer, sizeof(buffer), "%" PRId64,
+					 *((struct config_int64 *) record)->variable);
 			return buffer;
 
 		case PGC_REAL:
@@ -4711,8 +4709,8 @@ GetConfigOptionResetString(const char *name)
 			return buffer;
 
 		case PGC_INT64:
-			snprintf(buffer, sizeof(buffer), "%lld",
-					 (long long) ((struct config_int64 *) record)->reset_val);
+			snprintf(buffer, sizeof(buffer), "%" PRId64,
+					 ((struct config_int64 *) record)->reset_val);
 			return buffer;
 
 		case PGC_REAL:
@@ -5815,8 +5813,8 @@ ShowGUCOption(struct config_generic *record, bool use_units)
 					val = (*conf->show_hook) ();
 				else
 				{
-					snprintf(buffer, sizeof(buffer), "%lld",
-							 (long long) *conf->variable);
+					snprintf(buffer, sizeof(buffer), "%" PRId64,
+							 *conf->variable);
 					val = buffer;
 				}
 			}
@@ -5928,7 +5926,7 @@ write_one_nondefault_variable(FILE *fp, struct config_generic *gconf)
 			{
 				struct config_int64 *conf = (struct config_int64 *) gconf;
 
-				fprintf(fp, "%lld", (long long) *conf->variable);
+				fprintf(fp, "%" PRId64, *conf->variable);
 			}
 			break;
 
@@ -6392,7 +6390,7 @@ serialize_variable(char **destptr, Size *maxbytes,
 			{
 				struct config_int64 *conf = (struct config_int64 *) gconf;
 
-				do_serialize(destptr, maxbytes, "%lld", (long long) *conf->variable);
+				do_serialize(destptr, maxbytes, "%" PRId64, *conf->variable);
 			}
 			break;
 
@@ -7237,8 +7235,8 @@ call_int64_check_hook(struct config_int64 *conf, int64 *newval, void **extra,
 				(errcode(GUC_check_errcode_value),
 				 GUC_check_errmsg_string ?
 				 errmsg_internal("%s", GUC_check_errmsg_string) :
-				 errmsg("invalid value for parameter \"%s\": %lld",
-						conf->gen.name, (long long) *newval),
+				 errmsg("invalid value for parameter \"%s\": %" PRId64,
+						conf->gen.name, *newval),
 				 GUC_check_errdetail_string ?
 				 errdetail_internal("%s", GUC_check_errdetail_string) : 0,
 				 GUC_check_errhint_string ?
diff --git a/src/backend/utils/misc/guc_funcs.c b/src/backend/utils/misc/guc_funcs.c
index 4f94b9b844..b5bd3e0863 100644
--- a/src/backend/utils/misc/guc_funcs.c
+++ b/src/backend/utils/misc/guc_funcs.c
@@ -678,22 +678,22 @@ GetConfigOptionValues(struct config_generic *conf, const char **values)
 				struct config_int64 *lconf = (struct config_int64 *) conf;
 
 				/* min_val */
-				snprintf(buffer, sizeof(buffer), "%lld", (long long) lconf->min);
+				snprintf(buffer, sizeof(buffer), "%" PRId64, lconf->min);
 				values[9] = pstrdup(buffer);
 
 				/* max_val */
-				snprintf(buffer, sizeof(buffer), "%lld", (long long) lconf->max);
+				snprintf(buffer, sizeof(buffer), "%" PRId64, lconf->max);
 				values[10] = pstrdup(buffer);
 
 				/* enumvals */
 				values[11] = NULL;
 
 				/* boot_val */
-				snprintf(buffer, sizeof(buffer), "%lld", (long long) lconf->boot_val);
+				snprintf(buffer, sizeof(buffer), "%" PRId64, lconf->boot_val);
 				values[12] = pstrdup(buffer);
 
 				/* reset_val */
-				snprintf(buffer, sizeof(buffer), "%lld", (long long) lconf->reset_val);
+				snprintf(buffer, sizeof(buffer), "%" PRId64, lconf->reset_val);
 				values[13] = pstrdup(buffer);
 			}
 			break;
diff --git a/src/backend/utils/misc/help_config.c b/src/backend/utils/misc/help_config.c
index 88daad32c1..e0d3322e82 100644
--- a/src/backend/utils/misc/help_config.c
+++ b/src/backend/utils/misc/help_config.c
@@ -108,10 +108,10 @@ printMixedStruct(mixedStruct *structToPrint)
 				   structToPrint->integer.max);
 			break;
 		case PGC_INT64:
-			printf("INT64\t%lld\t%lld\t%lld\t",
-				   (long long) structToPrint->integer8.reset_val,
-				   (long long) structToPrint->integer8.min,
-				   (long long) structToPrint->integer8.max);
+			printf("INT64\t%" PRId64 "\t%" PRId64 "\t%" PRId64 "\t",
+				   structToPrint->integer8.reset_val,
+				   structToPrint->integer8.min,
+				   structToPrint->integer8.max);
 			break;
 		case PGC_REAL:
 			printf("REAL\t%g\t%g\t%g\t",
diff --git a/src/backend/utils/misc/pg_controldata.c b/src/backend/utils/misc/pg_controldata.c
index a7803cfaef..7a884ba871 100644
--- a/src/backend/utils/misc/pg_controldata.c
+++ b/src/backend/utils/misc/pg_controldata.c
@@ -116,8 +116,8 @@ pg_control_checkpoint(PG_FUNCTION_ARGS)
 	values[5] = BoolGetDatum(ControlFile->checkPointCopy.fullPageWrites);
 	nulls[5] = false;
 
-	values[6] = CStringGetTextDatum(psprintf("%llu",
-											 (unsigned long long) XidFromFullTransactionId(ControlFile->checkPointCopy.nextXid)));
+	values[6] = CStringGetTextDatum(psprintf("%" PRIu64,
+											 XidFromFullTransactionId(ControlFile->checkPointCopy.nextXid)));
 	nulls[6] = false;
 
 	values[7] = ObjectIdGetDatum(ControlFile->checkPointCopy.nextOid);
diff --git a/src/backend/utils/time/snapmgr.c b/src/backend/utils/time/snapmgr.c
index c9070b1915..811f0ef0f7 100644
--- a/src/backend/utils/time/snapmgr.c
+++ b/src/backend/utils/time/snapmgr.c
@@ -1157,8 +1157,8 @@ ExportSnapshot(Snapshot snapshot)
 	 * Generate file path for the snapshot.  We start numbering of snapshots
 	 * inside the transaction from 1.
 	 */
-	snprintf(path, sizeof(path), SNAPSHOT_EXPORT_DIR "/%08X-%016llX-%d",
-			 MyProc->vxid.procNumber, (unsigned long long) MyProc->vxid.lxid,
+	snprintf(path, sizeof(path), SNAPSHOT_EXPORT_DIR "/%08X-%016" PRIX64 "-%d",
+			 MyProc->vxid.procNumber, MyProc->vxid.lxid,
 			 list_length(exportedSnapshots) + 1);
 
 	/*
@@ -1186,15 +1186,15 @@ ExportSnapshot(Snapshot snapshot)
 	 */
 	initStringInfo(&buf);
 
-	appendStringInfo(&buf, "vxid:%d/%llu\n", MyProc->vxid.procNumber,
-					 (unsigned long long) MyProc->vxid.lxid);
+	appendStringInfo(&buf, "vxid:%d/%" PRIu64 "\n", MyProc->vxid.procNumber,
+					 MyProc->vxid.lxid);
 	appendStringInfo(&buf, "pid:%d\n", MyProcPid);
 	appendStringInfo(&buf, "dbid:%u\n", MyDatabaseId);
 	appendStringInfo(&buf, "iso:%d\n", XactIsoLevel);
 	appendStringInfo(&buf, "ro:%d\n", XactReadOnly);
 
-	appendStringInfo(&buf, "xmin:%llu\n", (unsigned long long) snapshot->xmin);
-	appendStringInfo(&buf, "xmax:%llu\n", (unsigned long long) snapshot->xmax);
+	appendStringInfo(&buf, "xmin:%" PRIu64 "\n", snapshot->xmin);
+	appendStringInfo(&buf, "xmax:%" PRIu64 "\n", snapshot->xmax);
 
 	/*
 	 * We must include our own top transaction ID in the top-xid data, since
@@ -1211,10 +1211,9 @@ ExportSnapshot(Snapshot snapshot)
 				 TransactionIdPrecedes(topXid, snapshot->xmax)) ? 1 : 0;
 	appendStringInfo(&buf, "xcnt:%d\n", snapshot->xcnt + addTopXid);
 	for (i = 0; i < snapshot->xcnt; i++)
-		appendStringInfo(&buf, "xip:%llu\n",
-						 (unsigned long long) snapshot->xip[i]);
+		appendStringInfo(&buf, "xip:%" PRIu64 "\n", snapshot->xip[i]);
 	if (addTopXid)
-		appendStringInfo(&buf, "xip:%llu\n", (unsigned long long) topXid);
+		appendStringInfo(&buf, "xip:%" PRIu64 "\n", topXid);
 
 	/*
 	 * Similarly, we add our subcommitted child XIDs to the subxid data. Here,
@@ -1228,11 +1227,9 @@ ExportSnapshot(Snapshot snapshot)
 		appendStringInfoString(&buf, "sof:0\n");
 		appendStringInfo(&buf, "sxcnt:%d\n", snapshot->subxcnt + nchildren);
 		for (i = 0; i < snapshot->subxcnt; i++)
-			appendStringInfo(&buf, "sxp:%llu\n",
-							 (unsigned long long) snapshot->subxip[i]);
+			appendStringInfo(&buf, "sxp:%" PRIu64 "\n", snapshot->subxip[i]);
 		for (i = 0; i < nchildren; i++)
-			appendStringInfo(&buf, "sxp:%llu\n",
-							 (unsigned long long) children[i]);
+			appendStringInfo(&buf, "sxp:%" PRIu64 "\n", children[i]);
 	}
 	appendStringInfo(&buf, "rec:%u\n", snapshot->takenDuringRecovery);
 
@@ -1335,7 +1332,7 @@ parseXidFromText(const char *prefix, char **s, const char *filename)
 				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
 				 errmsg("invalid snapshot data in file \"%s\"", filename)));
 	ptr += prefixlen;
-	if (sscanf(ptr, "%llu", (unsigned long long *) &val) != 1)
+	if (sscanf(ptr, "%" PRIu64, &val) != 1)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
 				 errmsg("invalid snapshot data in file \"%s\"", filename)));
@@ -1360,8 +1357,8 @@ parseVxidFromText(const char *prefix, char **s, const char *filename,
 				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
 				 errmsg("invalid snapshot data in file \"%s\"", filename)));
 	ptr += prefixlen;
-	if (sscanf(ptr, "%d/" "%llu", &vxid->procNumber,
-			   (unsigned long long *) &vxid->localTransactionId) != 2)
+	if (sscanf(ptr, "%d/" "%" PRIu64, &vxid->procNumber,
+			   &vxid->localTransactionId) != 2)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
 				 errmsg("invalid snapshot data in file \"%s\"", filename)));
diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index cc037516a1..7764172bc1 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -1589,7 +1589,7 @@ bootstrap_template1(void)
 							  escape_quotes_bki(username));
 
 	/* relfrozenxid must not be less than FirstNormalTransactionId */
-	sprintf(buf, "%llu", (unsigned long long) Max(start_xid, 3));
+	sprintf(buf, "%" PRIu64, Max(start_xid, 3));
 	bki_lines = replace_token(bki_lines, "RECENTXMIN",
 							  buf);
 
@@ -1618,9 +1618,9 @@ bootstrap_template1(void)
 
 	printfPQExpBuffer(&cmd, "\"%s\" --boot %s %s", backend_exec, boot_options, extra_options);
 	appendPQExpBuffer(&cmd, " -X %d", wal_segment_size_mb * (1024 * 1024));
-	appendPQExpBuffer(&cmd, " -m %llu", (unsigned long long) start_mxid);
-	appendPQExpBuffer(&cmd, " -o %llu", (unsigned long long) start_mxoff);
-	appendPQExpBuffer(&cmd, " -x %llu", (unsigned long long) start_xid);
+	appendPQExpBuffer(&cmd, " -m %" PRIu64, start_mxid);
+	appendPQExpBuffer(&cmd, " -o %" PRIu64, start_mxoff);
+	appendPQExpBuffer(&cmd, " -x %" PRIu64, start_xid);
 	if (data_checksums)
 		appendPQExpBufferStr(&cmd, " -k");
 	if (debug)
@@ -3112,16 +3112,16 @@ initialize_data_directory(void)
 	setup_config();
 
 	if (start_mxid != 0)
-		printf(_("selecting initial multixact id ... %llu\n"),
-				 (unsigned long long) start_mxid);
+		printf(_("selecting initial multixact id ... %" PRIu64 "\n"),
+				 start_mxid);
 
 	if (start_mxoff != 0)
-		printf(_("selecting initial multixact offset ... %llu\n"),
-				 (unsigned long long) start_mxoff);
+		printf(_("selecting initial multixact offset ... %" PRIu64 "\n"),
+				 start_mxoff);
 
 	if (start_xid != 0)
-		printf(_("selecting initial xid ... %llu\n"),
-				 (unsigned long long) start_xid);
+		printf(_("selecting initial xid ... %" PRIu64 "\n"),
+				 start_xid);
 
 	/* Bootstrap template1 */
 	bootstrap_template1();
@@ -3141,9 +3141,9 @@ initialize_data_directory(void)
 	initPQExpBuffer(&cmd);
 	printfPQExpBuffer(&cmd, "\"%s\" %s %s",
 					  backend_exec, backend_options, extra_options);
-	appendPQExpBuffer(&cmd, " -m %llu", (unsigned long long) start_mxid);
-	appendPQExpBuffer(&cmd, " -o %llu", (unsigned long long) start_mxoff);
-	appendPQExpBuffer(&cmd, " -x %llu", (unsigned long long) start_xid);
+	appendPQExpBuffer(&cmd, " -m %" PRIu64, start_mxid);
+	appendPQExpBuffer(&cmd, " -o %" PRIu64, start_mxoff);
+	appendPQExpBuffer(&cmd, " -x %" PRIu64, start_xid);
 	appendPQExpBuffer(&cmd, " template1 >%s", DEVNULL);
 
 	PG_CMD_OPEN(cmd.data);
diff --git a/src/bin/pg_controldata/pg_controldata.c b/src/bin/pg_controldata/pg_controldata.c
index 0992bb2bdd..6248201b8e 100644
--- a/src/bin/pg_controldata/pg_controldata.c
+++ b/src/bin/pg_controldata/pg_controldata.c
@@ -257,28 +257,28 @@ main(int argc, char *argv[])
 		   ControlFile->checkPointCopy.PrevTimeLineID);
 	printf(_("Latest checkpoint's full_page_writes: %s\n"),
 		   ControlFile->checkPointCopy.fullPageWrites ? _("on") : _("off"));
-	printf(_("Latest checkpoint's NextXID:          %llu\n"),
-		   (unsigned long long) XidFromFullTransactionId(ControlFile->checkPointCopy.nextXid));
+	printf(_("Latest checkpoint's NextXID:          %" PRIu64 "\n"),
+		   XidFromFullTransactionId(ControlFile->checkPointCopy.nextXid));
 	printf(_("Latest checkpoint's NextOID:          %u\n"),
 		   ControlFile->checkPointCopy.nextOid);
-	printf(_("Latest checkpoint's NextMultiXactId:  %llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.nextMulti);
-	printf(_("Latest checkpoint's NextMultiOffset:  %llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.nextMultiOffset);
-	printf(_("Latest checkpoint's oldestXID:        %llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.oldestXid);
+	printf(_("Latest checkpoint's NextMultiXactId:  %" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.nextMulti);
+	printf(_("Latest checkpoint's NextMultiOffset:  %" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.nextMultiOffset);
+	printf(_("Latest checkpoint's oldestXID:        %" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.oldestXid);
 	printf(_("Latest checkpoint's oldestXID's DB:   %u\n"),
 		   ControlFile->checkPointCopy.oldestXidDB);
-	printf(_("Latest checkpoint's oldestActiveXID:  %llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.oldestActiveXid);
-	printf(_("Latest checkpoint's oldestMultiXid:   %llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.oldestMulti);
+	printf(_("Latest checkpoint's oldestActiveXID:  %" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.oldestActiveXid);
+	printf(_("Latest checkpoint's oldestMultiXid:   %" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.oldestMulti);
 	printf(_("Latest checkpoint's oldestMulti's DB: %u\n"),
 		   ControlFile->checkPointCopy.oldestMultiDB);
-	printf(_("Latest checkpoint's oldestCommitTsXid:%llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.oldestCommitTsXid);
-	printf(_("Latest checkpoint's newestCommitTsXid:%llu\n"),
-		   (unsigned long long) ControlFile->checkPointCopy.newestCommitTsXid);
+	printf(_("Latest checkpoint's oldestCommitTsXid:%" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.oldestCommitTsXid);
+	printf(_("Latest checkpoint's newestCommitTsXid:%" PRIu64 "\n"),
+		   ControlFile->checkPointCopy.newestCommitTsXid);
 	printf(_("Time of latest checkpoint:            %s\n"),
 		   ckpttime_str);
 	printf(_("Fake LSN counter for unlogged rels:   %X/%X\n"),
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index 30b0b4be23..5f407606e6 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -3552,10 +3552,9 @@ dumpDatabase(Archive *fout)
 	{
 		appendPQExpBufferStr(creaQry, "\n-- For binary upgrade, set datfrozenxid and datminmxid.\n");
 		appendPQExpBuffer(creaQry, "UPDATE pg_catalog.pg_database\n"
-						  "SET datfrozenxid = '%llu', datminmxid = '%llu'\n"
+						  "SET datfrozenxid = '%" PRIu64 "', datminmxid = '%" PRIu64 "'\n"
 						  "WHERE datname = ",
-						  (unsigned long long) frozenxid,
-						  (unsigned long long) minmxid);
+						  frozenxid, minmxid);
 		appendStringLiteralAH(creaQry, datname, fout);
 		appendPQExpBufferStr(creaQry, ";\n");
 	}
@@ -3614,16 +3613,12 @@ dumpDatabase(Archive *fout)
 			RelFileNumber relfilenumber;
 
 			appendPQExpBuffer(loHorizonQry, "UPDATE pg_catalog.pg_class\n"
-							  "SET relfrozenxid = '%llu', relminmxid = '%llu'\n"
+							  "SET relfrozenxid = '%" PRIu64 "', relminmxid = '%" PRIu64 "'\n"
 							  "WHERE oid = %u;\n",
-							  (unsigned long long) strtou64(PQgetvalue(lo_res,
-																	   i,
-																	   ii_relfrozenxid),
-															NULL, 0),
-							  (unsigned long long) strtou64(PQgetvalue(lo_res,
-																	   i,
-																	   ii_relminmxid),
-															NULL, 0),
+							   strtou64(PQgetvalue(lo_res, i, ii_relfrozenxid),
+										NULL, 0),
+							   strtou64(PQgetvalue(lo_res, i, ii_relminmxid),
+										NULL, 0),
 							  atooid(PQgetvalue(lo_res, i, ii_oid)));
 
 			oid = atooid(PQgetvalue(lo_res, i, ii_oid));
@@ -17489,10 +17484,9 @@ dumpTableSchema(Archive *fout, const TableInfo *tbinfo)
 		{
 			appendPQExpBufferStr(q, "\n-- For binary upgrade, set heap's relfrozenxid and relminmxid\n");
 			appendPQExpBuffer(q, "UPDATE pg_catalog.pg_class\n"
-							  "SET relfrozenxid = '%llu', relminmxid = '%llu'\n"
+							  "SET relfrozenxid = '%" PRIu64 "', relminmxid = '%" PRIu64 "'\n"
 							  "WHERE oid = ",
-							  (unsigned long long) tbinfo->frozenxid,
-							  (unsigned long long) tbinfo->minmxid);
+							  tbinfo->frozenxid, tbinfo->minmxid);
 			appendStringLiteralAH(q, qualrelname, fout);
 			appendPQExpBufferStr(q, "::pg_catalog.regclass;\n");
 
@@ -17504,11 +17498,10 @@ dumpTableSchema(Archive *fout, const TableInfo *tbinfo)
 				 */
 				appendPQExpBufferStr(q, "\n-- For binary upgrade, set toast's relfrozenxid and relminmxid\n");
 				appendPQExpBuffer(q, "UPDATE pg_catalog.pg_class\n"
-								  "SET relfrozenxid = '%llu', relminmxid = '%llu'\n"
+								  "SET relfrozenxid = '%" PRIu64 "', relminmxid = '%" PRIu64 "'\n"
 								  "WHERE oid = '%u';\n",
-								  (unsigned long long) tbinfo->toast_frozenxid,
-								  (unsigned long long) tbinfo->toast_minmxid,
-								  tbinfo->toast_oid);
+								  tbinfo->toast_frozenxid,
+								  tbinfo->toast_minmxid, tbinfo->toast_oid);
 			}
 		}
 
